require "rstsyn/version"

class String
  def left_add_spaces val
    extra_spaces = ''
    val.times {extra_spaces += ' '}
    return "#{extra_spaces}#{self.strip}"
  end

  def left_add_spaces! val
    self.replace(left_add_spaces val)
  end
end

module Rstsyn

  class Parser
    @min_spaces = 50

    def self.start file_contents
      converted_file = Array.new
      potentional_heading = ''

      file_contents.each do |line|
        line.gsub!(/\t/, '   ')

        if (!potentional_heading.empty?)
          converted_file << potentional_heading

          if self.isTildeLine? line
            line = self.createTildeLine(potentional_heading.strip.length)
          end
        end

        potentional_heading = ''
        if self.isCommandwithParameters? line # :command:      Parameters
          converted_file << self.clean_command(line)
        elsif self.isAdditionalParameter? line  #                   Additional Paramaters
          converted_file << self.clean_additional(line)
        else # Everything Else
          potentional_heading = line
        end
      end

      converted_file << potentional_heading

      return converted_file
    end


    def self.createTildeLine length
      line = ''
      length.times {line += '~'}
      return line
    end


    def self.clean_additional line
      return line.left_add_spaces!(@min_spaces)
    end


    def self.clean_command line
      command = /^(?<command>\:\w+\:)\s+(?<params>.+)/.match(line)
      return "#{command['command'].ljust(@min_spaces)}#{command['params']}"
    end

    def self.isCommandwithParameters? line
      return (/^\:\w+\:\s+./ =~ line)
    end

    def self.isAdditionalParameter? line
      return (/^\s+./ =~ line)
    end

    def self.isTildeLine? line
      return (/^~~/ =~ line)
    end
  end
end
